#lang scheme

(require "check-lib.ss"
         "../eval/eval-exp.ss")

(define basedir "/Users/robby/Desktop/testsuite-5a")

(define (good-test-case file.tig)
  (let* ([p (well-formed-test-case-file file.tig)]
         [t (thread 
             (λ ()
               (eval-exp (syntax->datum p))))])
    (unless (sync/timeout 10 t)
      (error 'timeout "the program did not terminate after 10 seconds"))))

(define test-cases (directory-list basedir))

(define answers
  (map (λ (x) 
         (list (path->string x) 
               (with-handlers ((exn:fail? exn-message)) 
                 (good-test-case (build-path basedir x))
                 'good)))
       test-cases))

(define (is-good? x) (not (string? (cadr x))))

(define good (filter is-good? answers))
(define bad (filter (compose not is-good?) answers))