#lang s-exp syntax/module-reader
"eval/cub-lang.ss"
#:read read-cub
#:read-syntax read-syntax-cub
#:whole-body-readers? #t

(require "1b/cub-packrat-parse.ss")

(define (read-cub [port (current-input-port)])
  (syntax->datum (read-syntax-cub (object-name port) port)))

(define (read-syntax-cub name port)
  (let ([fst (packrat-parse-port port name)])
    (unless fst
      (raise-syntax-error 'cub "parse error"))
    (let-values ([(line col pos) (port-next-location port)])
      (unless (eof-object? (read-char port))
        (raise (make-exn:fail:read "expected eof, found more"
                                   (current-continuation-marks)
                                   (list (make-srcloc name
                                                      #f #f 
                                                      pos
                                                      (+ pos 1))))))
      (list fst))))
