#lang scheme
(require redex "tree-exp-red.ss")

;; the function 'traces' accepts a reduction system (in this case 
;; tree-exp-red) and an expression and then opens a window
;; showing how that expression reduces. In this example,
;; we start with an empty store and the program counter
;; at the beginning of a sequence of statements.
;; First, it updates memory location 128, then jumps
;; over (thereby skipping) another update, and then 
;; finally doubles the value in memory location 128.

;; Hit 'Run' to try this out.

(traces tree-exp-red
        '(()
          pc
          (move (mem 128) 4)
          (jump l:x l:x)
          (move (mem 128) 12)
          l:x
          (move (mem 128) (+ (mem 128) (mem 128)))))
